#!/usr/bin/perl -sw -I../lib
use strict;
use IO::Pty::Script qw{TIMEOUT DEFAULT_DEADLINE};

my %script;
our($c, $d, $p, $f); # Inicializadas via -s switch

$p = '' unless defined($p);
$d = DEFAULT_DEADLINE unless defined($d);
$f = '' unless defined($f);
die "Usage:$0 -c=command -p=key -d=deadline -f=script\n" 
                                      unless defined($c);  
my $prompt = '[$>]\s+';

$script{'ssh -l casiano etsii'} = [
'.*password:\s'           => "$p\n",
'(word:\s)|(login: )|(> )' => "$f\n",
$prompt                    => "exit\n"
];

#$script{'ssh -l casiano etsii'} = [
#'.*password:\s'           => "$p\n",
#'.*q para salir.\s\s\s\s' => "millo\n",
#'word:\s'                 => "$p\n",
#'(word:\s)|(login: )|(> )' => "$f\n",
#$prompt                    => "exit\n"
#];

$script{'ssh -l casiano beowulf'} = [
'.*password:\s'           => "$p\n",
$prompt                   => "$f\n",
$prompt                   => "exit\n"
];

#$script{'ssh europa'} = [
#$prompt                   => "$f\n",
#$prompt                   => [\&titi, 1, 2, "tres"],
#$prompt                   => "exit\n"
#];

$script{'ssh europa'} = [
$prompt                   => "$f\n",
$prompt                   => [\&titi, 1, 2, "tres"],
$prompt                   => sub { my $self = shift; $self->keyboard("\cD"); "ls\n" },
$prompt                   => "echo 'Despues de la interaccion'\n",
$prompt                   => "exit\n"
];

sub tutu { 
  print "<<sub tutu:\n";
  print $_[0];
  print "Es posible leer en la terminal\n" if $_[0]->can_read(TIMEOUT);
  print "Es posible escribir en la terminal\n" if $_[0]->can_write(TIMEOUT);
  print "end sub tutu>>\n";
  "8*2\n" 
}

sub titi {
  local $" = "\nsub titi:";
  print "<<sub titi: @_>>\n";
  "date\n";
}

$script{bc} = [
'warranty..\s\s' => "$f\n",
'\d+\.?\d*\s+' => \&tutu,
'\d+\.?\d*\s+' => "4*2\n",
'\d+\.?\d*\s+' => "quit",
];

my $s = IO::Pty::Script->new(
          command => $c, 
          deadline => $d, 
          script => $script{$c},
          defaultaction => sub { print $_[0] } 
        );
$s->chat();
